CSIT-1407 FIX vpp install after VPP changes
[csit.git] / resources / libraries / bash / function / artifacts.sh
1 #!/usr/bin/env bash
2
3 # Copyright (c) 2018 Cisco and/or its affiliates.
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at:
7 #
8 #     http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 set -exuo pipefail
17
18 function download_artifacts () {
19     # Get and/or install VPP artifacts from packagecloud.io.
20     #
21     # Variables read:
22     # - CSIT_DIR - Path to existing root of local CSIT git repository.
23     # Variables set:
24     # - REPO_URL - FD.io Packagecloud repository.
25
26     set -exuo pipefail
27
28     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
29         die "Get OS release failed."
30     }
31
32     repo_url_path="${CSIT_DIR}/VPP_REPO_URL"
33     if [ -e "${repo_url_path}" ]; then
34         REPO_URL="$(<${repo_url_path})" || {
35             die "Read repo URL from ${repo_url_path} failed."
36         }
37     else
38         REPO_URL="https://packagecloud.io/install/repositories/fdio/master"
39     fi
40
41     if [ "${os_id}" == "ubuntu" ]; then
42         download_ubuntu_artifacts || die
43     elif [ "${os_id}" == "centos" ]; then
44         download_centos_artifacts || die
45     elif [ "${os_id}" == "opensuse" ]; then
46         download_opensuse_artifacts || die
47     else
48         die "${os_id} is not yet supported."
49     fi
50 }
51
52 function download_ubuntu_artifacts () {
53     # Get and/or install Ubuntu VPP artifacts from packagecloud.io.
54     #
55     # Variables read:
56     # - REPO_URL - FD.io Packagecloud repository.
57     # - VPP_VERSION - VPP version.
58     # - INSTALL - If install packages or download only. Default: download
59
60     set -exuo pipefail
61
62     curl -s "${REPO_URL}"/script.deb.sh | sudo bash || {
63         die "Packagecloud FD.io repo fetch failed."
64     }
65     # If version is set we will add suffix.
66     artifacts=()
67     vpp=(vpp vpp-dbg vpp-dev vpp-api-python libvppinfra libvppinfra-dev
68          vpp-plugin-core vpp-plugin-dpdk)
69     if [ -z "${VPP_VERSION-}" ]; then
70         artifacts+=(${vpp[@]})
71     else
72         artifacts+=(${vpp[@]/%/=${VPP_VERSION-}})
73     fi
74
75     if [ "${INSTALL:-false}" = true ]; then
76         sudo apt-get -y install "${artifacts[@]}" || {
77             die "Install VPP artifacts failed."
78         }
79     else
80         apt-get -y download "${artifacts[@]}" || {
81             die "Download VPP artifacts failed."
82         }
83     fi
84 }
85
86 function download_centos_artifacts () {
87     # Get and/or install CentOS VPP artifacts from packagecloud.io.
88     #
89     # Variables read:
90     # - REPO_URL - FD.io Packagecloud repository.
91     # - VPP_VERSION - VPP version.
92     # - INSTALL - If install packages or download only. Default: download
93
94     set -exuo pipefail
95
96     curl -s "${REPO_URL}"/script.rpm.sh | sudo bash || {
97         die "Packagecloud FD.io repo fetch failed."
98     }
99     # If version is set we will add suffix.
100     artifacts=()
101     vpp=(vpp vpp-selinux-policy vpp-devel vpp-lib vpp-plugins vpp-api-python)
102     if [ -z "${VPP_VERSION-}" ]; then
103         artifacts+=(${vpp[@]})
104     else
105         artifacts+=(${vpp[@]/%/-${VPP_VERSION-}})
106     fi
107
108     if [ "${INSTALL:-false}" = true ]; then
109         sudo yum -y install "${artifacts[@]}" || {
110             die "Install VPP artifact failed."
111         }
112     else
113         sudo yum -y install --downloadonly --downloaddir=. "${artifacts[@]}" || {
114             die "Download VPP artifacts failed."
115         }
116     fi
117 }
118
119 function download_opensuse_artifacts () {
120     # Get and/or install OpenSuSE VPP artifacts from packagecloud.io.
121     #
122     # Variables read:
123     # - REPO_URL - FD.io Packagecloud repository.
124     # - VPP_VERSION - VPP version.
125     # - INSTALL - If install packages or download only. Default: download
126
127     set -exuo pipefail
128
129     curl -s "${REPO_URL}"/script.rpm.sh | sudo bash || {
130         die "Packagecloud FD.io repo fetch failed."
131     }
132     # If version is set we will add suffix.
133     artifacts=()
134     vpp=(vpp vpp-devel vpp-lib vpp-plugins libvpp0)
135     if [ -z "${VPP_VERSION-}" ]; then
136         artifacts+=(${vpp[@]})
137     else
138         artifacts+=(${vpp[@]/%/-${VPP_VERSION-}})
139     fi
140
141     if [ "${INSTALL:-false}" = true ]; then
142         sudo yum -y install "${artifacts[@]}" || {
143             die "Install VPP artifact failed."
144         }
145     else
146         sudo yum -y install --downloadonly --downloaddir=. "${artifacts[@]}" || {
147             die "Download VPP artifacts failed."
148         }
149     fi
150 }
151